<?

/*
eveQuery: Classe para interao com banco de dados

-----------------------------------------------------

Desenvolvido por Everton da Rosa.
Licena GNU (www.gnu.org).

-----------------------------------------------------

eveFile  uma classe PHP para manipulao de arquivos.
Verso 1.1 (19 de novembro de 2007)

Funes: criar, salvar uploads, deletar, mover, copiar, renomear, pegar informaes, abrir, fechar

Futuro: informaes do diretrio

Para detalhes e ajuda complementar, consulte http://www.php.net/manual/pt_BR/index.php (manual em portugus do PHP)
Tpicos recomendados:
- Classes e Objetos (PHP 5): http://www.php.net/manual/pt_BR/language.oop5.php
- Variveis: http://www.php.net/manual/pt_BR/language.variables.php
- Funes do FileSystem: http://www.php.net/manual/pt_BR/ref.filesystem.php

Caso faa correes, melhorias ou modificaes, favor contatar o desenvolvedor atravs do e-mail everton3x@gmail.com enviando o cdigo para atualizao da classe nos sites onde ela se encontra hospedada.

Para exemplo de uso, veja o arquivo eveFile.samples.php

Ao utilizar esta classe, por favor indique seu autor da seguinte forma:
-----------------------------------------------------
eveFile: Classe para manipulao de arquivos

Desenvolvido por Everton da Rosa (everton3x@gmail.com).
Licena GNU (www.gnu.org).
-----------------------------------------------------

Ao utilizar cdigo baseado nesta classe, por favor referencie da seguinte forma:
-----------------------------------------------------
Baseado na classe eveFile: Classe para manipulao de arquivos, desenvolvida por Everton da Rosa (everton3x@gmail.com) sob licena GNU (www.gnu.org).
-----------------------------------------------------

*/

class eveFile{ //Classe para manipulao de arquivos
	
	public $param = array(
		'dir' => 'C:\Documents and Settings\Everton\Desktop\\', //diretrio padro da classe
		'save_dir' => 'C:\Documents and Settings\Everton\Desktop\\' //diretrio padro para salvar arquivos
	);
	
	function save($d=false){ //salva no destino um arquivo carregado por upload. $d  o diretrio de destino terminado com \
		$f = key($_FILES);
		if($f){
			if(!$d){
				$d = realpath($param['save_dir']);
			}
			
			if(!is_dir($d)){
				exit('O destino no  um diretrio!');
			}
			
			$m = @move_uploaded_file($_FILES[$f]['tmp_name'],$d.$_FILES[$f]['name']);
			if(!$m){
				exit(E_ALL);
			}else{
				return true;
			}
		}
	}
	
	function getName($path=false){ //retorna o nome do arquivo. $path deve conter o caminho completo, incluisve o nome do arquivo ex.: c:\teste.txt
		if(!is_file($path)){
			exit('O caminho informado no  um arquivo!');
		}
		
		if($path){
			$path = $realpath($path);
			$name = @basename($path);
			return $name;
		}else{
			exit('Nenhum caminho foi definido!');
		}
	}
	
	function getPath($path=false){ //retorna o caminho do arquivo. $path deve conter o caminho completo, incluisve o nome do arquivo ex.: c:\teste.txt
		if(!is_file($path)){
			exit('O caminho informado no  um arquivo!');
		}
		
		if($path){
			$path = realpath($path);
			$dir = @dirname($path);
			return $dir;
		}else{
			exit('Nenhum caminho foi definido!');
		}
	}
	
	function parse($size=false){ //retorna o tamanho de n bytes em Kb, Mb, Gb, etc.
		if(!size){
			exit('Nenhum tamanho foi passado!');
		}
				
		if($size<=1024){
			$parsed = array(
				'size' => $size,
				'unid' => 'Byte'
			);
		}else{
			$size = $size/1024;
			if($size < 1024){
				$parsed = array(
					'size' => $size,
					'unid' => 'Kbyte'
				);
			}else{
				$size = $size/1024;
				if($size < 1024){
					$parsed = array(
						'size' => $size,
						'unid' => 'Mbyte'
					);
				}else{
					$size = $size/1024;
					if($size < 1024){
						$parsed = array(
							'size' => $size,
							'unid' => 'Gbyte'
						);
					}else{
						$parsed = array(
							'size' => $size,
							'unid' => 'Gbyte'
						);
					}
				}
			}
		}
		
		return $parsed;
	}
	
	function free($path=false){ //exibe o espao disponvel no diretrio/disco
		if(!$path){
			$path = realpath($param['dir']);
		}
		
		if(!is_dir($path)){
			exit('O caminho informado no  um diretrio!');
		}
		
		$free = @disk_free_space($path);
		
		$parsed = $this->parse($free);
		
		return $parsed;
	}
	
	function sizeDir($path=false){ //exibe o tamanho total do diretrio/disco
		if(!$path){
			$path = realpath($param['dir']);
		}
		
		if(!is_dir($path)){
			exit('O caminho informado no  um diretrio!');
		}
		
		$free = @disk_total_space($path);
		
		$parsed = $this->parse($free);
		
		return $parsed;
	}
	
	function fm($option=false,$conf=false){ //funo para manipulao de arquivos
		if(!$option){
			exit('Nenhuma opo de manipulao foi informada!');
		}
		
		if($option == 'copy'){ //copia o arquivo
			if(!$conf['from']){
				exit('Origem no definida!');
			}else{
				$o = realpath($conf['from']);
			}
			
			if(!$conf['to']){
				exit('Destino no definido!');
			}else{
				$d = realpath($conf['to']);
			}
			
			if(!is_file($o)){
				exit("A origem $o no  um arquivo vlido!");
			}
			
			$c = @copy($o,$d);
			
			return $c;
		}elseif($option == 'move'){ //move um arquivo
			if(!$conf['from']){
				exit('Origem no definida!');
			}else{
				$o = realpath($conf['from']);
			}
			
			if(!$conf['to']){
				exit('Destino no definido!');
			}else{
				$d = realpath($conf['to']);
			}
			
			if(!is_file($o)){
				exit("A origem $o no  um arquivo vlido!");
			}
			
			$m = @rename($o,$d);
			
			return $m;
		}elseif($option == 'delete' || $option == 'del'){
			
			if(!$conf['file']){
				exit('Arquivo no definido!');
			}else{
				$f = realpath($conf['file']);
			}
			
			if(!is_file($f)){
				exit("O arquivo $f no  um arquivo vlido!");
			}
			
			$d = @unlink($f);
			
			return $d;
		}elseif($option == 'rename'){ //renomeia um arquivo
			if(!$conf['from']){
				exit('Origem no definida!');
			}else{
				$o = realpath($conf['from']);
			}
			
			if(!$conf['to']){
				exit('Destino no definido!');
			}else{
				$d = realpath($conf['to']);
			}
			
			if(!is_file($o)){
				exit("A origem $o no  um arquivo vlido!");
			}
			
			if(dirname($o) != dirname($d)){
				exit('Voc no pode renomear um arquivo para diretrios diferentes! Para mover, utilize a opo "move".');
			}
			
			$r = @rename($o,$d);
			
			return $r;
		}elseif($option == 'open'){// abre um arquivo
			if(!$conf['file']){
				exit('Nenhum arquivo informado!');
			}else{
				$file = realpath($conf['file']);
			}
			
			if(!$conf['mode']){
				$mode = 'rt';
			}else{
				$mode = $conf['mode'];
			}
			
			if(!is_file($file)){
				exit("O arquivo $file no  um arquivo vlido!");
			}
			
			$f = @fopen($file,$mode);
			
			return $f;
		}elseif($option == 'close'){ //fecha um arquivo
			if(!$conf['file']){
				exit('Nenhum arquivo informado!');
			}else{
				$file = $conf['file'];
			}
			
			$f = @fclose($file);
			return $f;
		}elseif($option == 'info'){ //retorna um array con informaes do arquivo
			if(!$conf['file']){
				exit('Nenhum arquivo informado!');
			}else{
				$file = realpath($conf['file']);
			}
			
			if(!is_file($file)){
				exit("O arquivo $file no  um arquivo vlido!");
			}
			
			$a['name'] = $this->getName($file);
			$a['dir'] = $this->getDir($file);
			$a['last_access'] = @fileatime($file);
			$a['last_modify'] = @filectime($file);
			$a['group'] = @filegroup($file);
			$a['owner'] = @fileowner($file);
			$a['perms'] = @fileperms($file);
			$a['size'] = @filesize($file);
			$a['type'] = @filetype($file);
			$a['exec'] = @is_executable($file);
			$a['readable'] = @is_readable($file);
			$a['writable'] = @is_writable($file);
			
			return $a;
		}elseif($option == 'read'){ //l o contedo do arquivo para um array
			if(!$conf['file']){
				exit('Nenhum arquivo definido!');
			}else{
				$file = realpath($conf['file']);
			}
			
			if(!is_file($file)){
				exit("O arquivo $file no  um arquivo vlido!");
			}
			
			$array = @file($file);
			
			return $array;
		}else{
			exit("Opo $option desconhecida!");
		}
	}
	
	function dm($option=false,$conf=false){ //funes de gerenciamneto de diretrios
		if(!option){
			exit('Nenhuma opo informada!');
		}
		
		if($option == 'new' || $option == 'create'){ //cria um diretrio
			if(!$config['dir']){
				exit('Nenhum diretrio informado!');
			}else{
				$dir = realpath($config['dir']);
			}
			
			$d = @mkdir($dir);
			
			return $d;
		}elseif($option == 'delete' || $option == 'del'){ //remove o diretrio
			if(!$config['dir']){
				exit('Nenhum diretrio informado!');
			}else{
				$dir = realpath($config['dir']);
			}
			
			if(!is_dir($dir)){
				exit("O diretrio $dir no  um diretrio vlido!");
			}
			
			$d = @rmdir($dir);
			
			return $d;
		}elseif($option == 'copy'){ //copia o diretrio
			if(!$conf['from']){
				exit('Origem no definida!');
			}else{
				$o = realpath($conf['from']);
			}
			
			if(!$conf['to']){
				exit('Destino no definido!');
			}else{
				$d = realpath($conf['to']);
			}
			
			if(!is_dir($o)){
				exit("A origem $o no  um diretrio vlido!");
			}
			
			$c = @copy($o,$d);
			
			return $c;
		}elseif($option == 'move'){ //move o diretrio
			if(!$conf['from']){
				exit('Origem no definida!');
			}else{
				$o = realpath($conf['from']);
			}
			
			if(!$conf['to']){
				exit('Destino no definido!');
			}else{
				$d = realpath($conf['to']);
			}
			
			if(!is_dir($o)){
				exit("A origem $o no  um diretrio vlido!");
			}
			
			$m = @rename($o,$d);
			
			return $m;
		}elseif($option == 'rename'){ //renomeia o diretrio
			if(!$conf['from']){
				exit('Origem no definida!');
			}else{
				$o = realpath($conf['from']);
			}
			
			if(!$conf['to']){
				exit('Destino no definido!');
			}else{
				$d = realpath($conf['to']);
			}
			
			if(!is_file($o)){
				exit("A origem $o no  um diretrio vlido!");
			}
			
			$r = @rename($o,$d);
			
			return $r;
		}else{
			exit("A opo $option  desconhecida!");
		}
	}
}

?>